Unit Animate;

INTERFACE

Uses Dos,Toetsen,Timer;

Const XVELD      = 36;  {X Dimensie}
      YVELD      = 21;  {Y Dimensie}
      XSTART     = 0;
      YSTART     = 30;
      BREEDTE    = 10;
      HOOGTE     = 10;
      IMMFACTOR  = 5;
      MAXGEMS    = 25; {Maximaal 50 GEM'S}

Type  ByteSet       = Set Of Byte;

      _Sprite_      = RECORD
                        Buffer : Array[1..HOOGTE*BREEDTE] Of Byte;
                        XRow   : INTEGER;
                        YRow   : INTEGER;
	                Xpos   : INTEGER;
	                Ypos   : INTEGER;
	                LastX  : INTEGER;
	                LastY  : INTEGER;
                        Active : Boolean;
                      END;

      _SpriteWijzer = ^_SpriteDef;
      _SpriteDef    = RECORD
                       Buffer : Array[1..HOOGTE,1..BREEDTE] Of Byte;
                     END;

      _FontWijzer   = ^_FontDef;
      _FontDef      = RECORD
                       Buffer : Array[1..8,1..8] Of Byte;
                     END;

      _ScreenWijzer = ^_ScreenDef;
      _ScreenDef    = RECORD
                       Buffer : Array[1..YVELD,1..XVELD] Of Byte;
                     END;

      _SpriteMemory = Array[0..200] Of _SpriteWijzer;
      _ScreenMemory = Array[1..100] Of _ScreenWijzer;
      _FontMemory   = Array[0..255] Of _FontWijzer;

      _PaletteRec   = Record
                        Red   : Byte;
                        Green : Byte;
                        Blue  : Byte;
                      End;
      _PaletteArr   = Array [0..255] of _PaletteRec;


Var   _DiskMan       : _Sprite_;
      _Vijand        : _Sprite_;
      _GEMRec        : Array[1..75] Of _Sprite_;
      _SpriteRec     : _SpriteMemory;
      _SpriteOnes    : _SpriteDef;
      _ScreenRec     : _ScreenMemory;

      _ScreenOnes    : _ScreenDef;
      _FontRec       : _FontMemory;
      _FontOnes      : _FontDef;
      _SpriteFile    : File Of _SpriteDef;
      _ScreenFile    : File Of _ScreenDef;
      _FontFile      : File Of _FontDef;
      _Palette       : _PaletteArr;
      _BewaarPalette : _PaletteArr;
      _PaletteBuffer : _PaletteArr;
      _MAX_SCREEN    : Word;
      _MAX_SPRITE    : Word;
      _MAX_FONT      : Word;



Procedure Init_ModeX(Mode,MaxXpos,MaxYpos,Pages : Integer);
Procedure DrawSprite(SNr : Byte; X,Y : Word);
Procedure ClearAll;
Procedure ClearFirst;
Procedure ClearSecond;

Procedure Game_Init;
Procedure Game_Stop;
Procedure SetPalette;
Procedure ReadScreen(S : String; Max : Word);
Procedure ReadSprite(S : String; Max : Word);
Procedure ReadFont(S : String; Max : Word);
Procedure ReadPalette(S : String);
Procedure GetScreen(VAR _Bld : _ScreenDef; _Nr : Word);
Procedure Init_Screen(_Bld             : _ScreenDef;
                      _DLopen,_Opeten,
                      _OpBouw,_Vijanden,
                      _BovenOnder,
                      _Stoppen,
                      _Uitgang         : ByteSet;
                      _XPos,_YPos      : Word);


Procedure Start_Animate(VAR _STOP : Boolean);

IMPLEMENTATION

{$I MODE.INC}

Const BITS = 2;
      _Leeg        = 0;
      _AchterGrond = 1;
      _DMStil      = 2;
      _DMDood      = 3;
      _DMRechts1   = 4;
      _DMRechts2   = 5;
      _DMLinks1    = 6;
      _DMLinks2    = 7;
      {TOT EN MET 19}

      _DM_Links    = 1;
      _DM_Rechts   = 2;
      _DM_Onder    = 3;
      _DM_Boven    = 4;

Type UitDef = RECORD
                Uit_Y : Byte;
                Uit_X : Byte;
              END;

Var   _DiskManBoolean,
      _VijandBoolean   : Boolean;
      _DiskManBits,
      _LinksRechts,
      _DiskLaatste,
      _Animatie,
      _DiskSpring,
      _XPos,
      _YPos            : Word;
      _AlienLaatste,
      _AlienLOrR,
      _AlienBits       : Array[1..10] Of Word; {Array?}
      _HuidigeScreen   : _ScreenDef;
      _GEMScreen       : _ScreenDef;
      _WEGHALEN        : Boolean;
      _DOORLOPEN       : Set Of Byte;
      _DBOVENONDER     : Set Of Byte;
      _DSTOPPEN        : Set Of Byte;
      _DUITGANG        : Set Of Byte;
      _DOPETEN         : Set Of Byte;
      _CurrentPage,
      _LastPage        : Integer; {PAGE FLIPPING}
      _STOPPEN         : Boolean; {Tijdelijk Stoppen}
      _SPRING_BOVEN    : Boolean;
      _Uitgangen_Count : Byte;
      _Uitgangen       : Array[1..10] Of UitDef;
      Kijk             : Array[1..10] Of Word;
      _Weg_XPos,
      _Weg_YPos        : Word;
      _GEMCount        : Byte;


      TXT : Text;

Procedure Error(S : String);
Begin
  WriteLn(S);
  Halt(255);
End;

Procedure Init_ModeX(Mode,MaxXpos,MaxYpos,Pages : Integer);
Begin
  {QUICK & DIRTY VOOR ROBERT}
  If SET_VGA_MODEX(Mode,MaxXpos,MaxYpos,Pages) = 0 Then Begin
    Game_Stop;
    Error('Error Init Mode...');
  End;
End;

Procedure DrawSprite(SNr : Byte; X,Y : Word);
Begin
  Draw_BitMap(_SpriteRec[SNr]^.Buffer,X,Y,BREEDTE,HOOGTE);
End;

Procedure ClearAll;
Begin
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(0);
End;

Procedure ClearFirst;
Begin
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(1);
End;

Procedure ClearSecond;
Begin
  Copy_Page(0,1);
  Copy_Page(0,2);
  Set_Display_Page(0);
End;

{************************************}

Procedure BufToDMan(Van : Byte);
Begin
  Move(_SpriteRec[Van]^,_DiskMan.Buffer,SizeOf(_SpriteRec[Van]^));
End;

Procedure RemoveAllSprites;
Var I : Word;
Begin
  Copy_Bitmap(2,_DiskMan.LastX,
                _DiskMan.LastY,
                _DiskMan.LastX+BREEDTE,
                _DiskMan.LastY+HOOGTE,
                _LastPage,
                _DiskMan.LastX,
                _DiskMan.LastY);

  Copy_Bitmap(2,_Vijand.LastX,
                _Vijand.LastY,
                _Vijand.LastX+BREEDTE,
                _Vijand.LastY+HOOGTE,
                _LastPage,
                _Vijand.LastX,
                _Vijand.LastY);

  For I := 1 To _GEMCount Do Begin
    Copy_Bitmap(2,_GEMRec[I].LastX,
                  _GEMRec[I].LastY,
                  _GEMRec[I].LastX+BREEDTE,
                  _GEMRec[I].LastY+HOOGTE,
                  _LastPage,
                  _GEMRec[I].LastX,
                  _GEMRec[I].LastY);
  End;
End;


Procedure UpDateAllSprites;
Var I : Word;
Begin
  If _DiskMan.Active = True Then Begin
    _DiskMan.LastX := _DiskMan.XPos;
    _DiskMan.LastY := _DiskMan.YPos;
  End;
  If _Vijand.Active = True Then Begin
    _Vijand.LastX := _Vijand.Xpos;
    _Vijand.LastY := _Vijand.Ypos;
  End;
  For I := 1 To _GEMCount Do Begin
    If _GEMRec[I].Active = True Then Begin
      _GEMRec[I].LastX := _GEMRec[I].Xpos;
      _GEMRec[I].LastY := _GEMRec[I].Ypos;
    End;
  End;
End;


{Alle Sprites naar Scherm}
Procedure DrawAllSprites;
Var I : Word;
Begin
  If _DiskMan.Active = True Then Begin
    TDraw_Bitmap(_DiskMan.Buffer,_DiskMan.XPos,_DiskMan.YPos,BREEDTE,HOOGTE);
  End;
  If _Vijand.Active = True Then Begin
    TDraw_Bitmap(_Vijand.Buffer,_Vijand.XPos,_Vijand.YPos,BREEDTE,HOOGTE);
  End;
  For I := 1 To _GEMCount Do Begin
    If _GEMRec[I].Active = True Then Begin
      TDraw_Bitmap(_GEMRec[I].Buffer,_GEMRec[I].XPos,_GEMRec[I].YPos,BREEDTE,HOOGTE);
    End;
  End;
End;

Function Exist(FileName : String) : Boolean;
Var SR : SearchRec;
Begin
  FindFirst(FileName, ReadOnly + Hidden + SysFile, SR);
  Exist := (DosError = 0) and (Pos('?', FileName) = 0) and
            (Pos('*', FileName) = 0);
End;

Procedure Game_Stop; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;

Procedure Game_Init;
Begin
  If _MAX_SCREEN = 0 Then Error('Screens not loaded...');
  If _MAX_SPRITE = 0 Then Error('Sprites not loaded...');
  If _MAX_FONT   = 0 Then Error('Fonts not loaded...');
  If SET_VGA_MODEX(6,360,240,3) = 0 Then Begin
    Game_Stop;
    Error('Error Init Mode...');
  End;
  SetPalette;
End;

{$I PALETTE.INC}

Procedure ReadScreen;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_ScreenFile,S);
    Reset(_ScreenFile);
    _MAX_SCREEN := Max;
    For Count := 1 To Max Do Begin
      Read(_ScreenFile,_ScreenOnes);
      GetMem(_ScreenRec[Count],SizeOf(_ScreenOnes));
      Move(_ScreenOnes,_ScreenRec[Count]^,SizeOf(_ScreenOnes));
    End;
    Close(_ScreenFile);
  End;
End;

Procedure ReadSprite;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_SpriteFile,S);
    Reset(_SpriteFile);
    _MAX_SPRITE := Max;
    For Count := 0 To Max Do Begin
      Read(_SpriteFile,_SpriteOnes);
      GetMem(_SpriteRec[Count],SizeOf(_SpriteOnes));
      Move(_SpriteOnes,_SpriteRec[Count]^,SizeOf(_SpriteOnes));
    End;
    Close(_SpriteFile);
  End;
End;

Procedure ReadFont;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_FontFile,S);
    Reset(_FontFile);
    _MAX_FONT := Max;
    For Count := 0 To Max Do Begin
      Read(_FontFile,_FontOnes);
      GetMem(_FontRec[Count],SizeOf(_FontOnes));
      Move(_FontOnes,_FontRec[Count]^,SizeOf(_FontOnes));
    End;
    Close(_FontFile);
  End;
End;

Procedure ReadPalette;
Var T       : Byte;
    F       : File;
    Gelezen : Word;

Begin
  If Exist(S) Then Begin
    Assign(F,S);
    Reset(F,1);
    BlockRead(F,_Palette,SizeOf(_Palette),Gelezen);
    Close(F);
  End Else Error(S+' Not found...');
End;

Procedure GetScreen;
Begin
  If (_Nr > 0) And (_Nr < _MAX_SCREEN+1) Then Begin
    _Bld := _ScreenRec[_Nr]^;
  End Else Error('Error GetScreen...');
End;

Procedure Init_New_Screen;
Begin
  FillChar(_DiskMan,SizeOf(_DiskMan),0);
  FillChar(Kijk,SizeOf(Kijk),0);
  _DiskManBoolean := False;
  _VijandBoolean := False; {Alleen voor 1 Alien}
  _DiskManBits := 0;
  _DiskLaatste := 0;
  _AlienLaatste[1] := 0;
  _AlienLOrR[1] := 0;
  _AlienBits[1] := 0;
  _LinksRechts := 0;
  _CurrentPage := 1;
  _LastPage := 0;
  _Animatie := 0;
  _DiskSpring := 0;
  FillChar(_Uitgangen,SizeOf(_Uitgangen),0);
End;

Procedure Init_Screen;
Var X,Y,I : Word;
Begin
  {LEES GEGEVENS OVER VIJANDEN EN DISKMAN}
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(1);
  Init_New_Screen;
  _HuidigeScreen := _Bld;
  _DOORLOPEN := _DLopen;
  _DBOVENONDER := _BovenOnder;
  _DSTOPPEN := _Stoppen;
  _DUITGANG := _Uitgang;
  _DBOVENONDER := _BovenOnder;
{  _DOPETEN := _OpEten;}
  _XPos := _Xpos;
  _YPos := _YPos;
  _GEMCount := 0;
  For Y := 0 To YVELD-1 Do Begin
    For X := 0 To XVELD-1 Do Begin
      I := _Bld.Buffer[Y+1,X+1];
      {OPBOUW BEELD}
      If (I In _OpBouw) Then
        TDraw_BitMap(_SpriteRec[I]^.Buffer,(X*BREEDTE)+_Xpos,(Y*HOOGTE)+_Ypos,BREEDTE,HOOGTE);
      {DISKMAN OP BEELD}
      If (I = _DMStil) And (_DiskManBoolean = False) Then Begin
        _DiskMan.XPos := (X*BREEDTE)+_Xpos;
        _DiskMan.YPos := (Y*HOOGTE)+_Ypos;
        _DiskMan.Active := True;
        Move(_SpriteRec[I]^,_DiskMan.Buffer,SizeOf(_SpriteRec[I]^));
        {_DiskManBuf := _DiskMan;}
        _DiskMan.XRow := X+1;
        _DiskMan.YRow := Y+1;
        _DiskManBoolean := True;
        _HuidigeScreen.Buffer[Y+1,X+1] := _AchterGrond;
        TDraw_BitMap(_SpriteRec[_AchterGrond]^.Buffer,(X*BREEDTE)+_Xpos,(Y*HOOGTE)+_Ypos,BREEDTE,HOOGTE);
      End;
      If (I in _Vijanden) And (_VijandBoolean = False) Then Begin
        _Vijand.XPos := (X*BREEDTE)+_Xpos;
        _Vijand.YPos := (Y*HOOGTE)+_Ypos;
        _Vijand.Active := True;
        Move(_SpriteRec[I]^,_Vijand.Buffer,SizeOf(_SpriteRec[I]^));
        {_VijandBuf := _VijandMan;}
        _Vijand.XRow := X+1;
        _Vijand.YRow := Y+1;
        _VijandBoolean := True;
        _HuidigeScreen.Buffer[Y+1,X+1] := _AchterGrond;
        TDraw_BitMap(_SpriteRec[_AchterGrond]^.Buffer,(X*BREEDTE)+_Xpos,(Y*HOOGTE)+_Ypos,BREEDTE,HOOGTE);
      End;
      {GEMS}
      If (I in _Opeten) And (_GEMCount < MAXGEMS) Then Begin
        Inc(_GEMCount);
        _GEMRec[_GEMCount].XPos := (X*BREEDTE)+_Xpos;
        _GEMRec[_GEMCount].YPos := (Y*HOOGTE)+_Ypos;
        _GEMRec[_GEMCount].Active := True;
        Move(_SpriteRec[I]^,_GEMRec[_GEMCount].Buffer,SizeOf(_SpriteRec[I]^));
        _GEMRec[_GEMCount].XRow := X+1;
        _GEMRec[_GEMCount].YRow := Y+1;
        _HuidigeScreen.Buffer[Y+1,X+1] := _AchterGrond;
        _GEMScreen.Buffer[Y+1,X+1] := _GEMCount; {Sprite# naar BeeldRec}
        TDraw_BitMap(_SpriteRec[_AchterGrond]^.Buffer,(X*BREEDTE)+_Xpos,(Y*HOOGTE)+_Ypos,BREEDTE,HOOGTE);
      End;
    End;
  End;
  Copy_Page(0,1);
  Copy_Page(0,2);
  Set_Display_Page(0);

End;

{$I SPRINGEN.INC}
{$I VIJAND.INC}
{$I MOVEDMAN.INC}

Procedure Start_Animate;
Begin
{  WriteLn(TXT,'CurrentPage : ',_CurrentPage);
  WriteLn(TXT,'LastPage    : ',_LastPage);
  WriteLn(TXT);}
  HaalToetsen;
  Set_Active_Page(_CurrentPage);
  UpDateAllSprites;
  BeweegVijand;
  DiskMan_Springen;
  BeweegDiskMan;
  DrawAllSprites;
  Set_Display_Page(_Currentpage);
  RemoveAllSprites;
  _LastPage := (_LastPage+1) MOD 2;
  _CurrentPage := (_CurrentPage+1) MOD 2;
  If ( (ESCAPE = True) Or (F10 = True) ) Then _STOP := True;
End;

Begin
{  Assign(TXT,'Eduard');Rewrite(TXT);}
  _MAX_SCREEN := 0;
  _MAX_SPRITE := 0;
  _MAX_FONT := 0;
  _STOPPEN := False;
  _SPRING_BOVEN := TRUE;
  _WEGHALEN := FALSE;
End.