Unit Sprite;

INTERFACE
Uses Mode,Def,Opslag;
{***************************************************************************}
Type  Move_Type   = (_None,_Left,_Right,_Up,_Down);

         _Sprite_ = RECORD
                     Buffer : _SprBuf_;
                     XRow   : INTEGER;
                     YRow   : INTEGER;
                     Xpos   : INTEGER;
                     Ypos   : INTEGER;
                     LastX  : INTEGER;
                     LastY  : INTEGER;
                     Active : (Ja,Nee,Dead);
                    END;

{*******MOEDER OBJECT SPRITE************************************************}
Type  OBJSprite = OBJECT

                   PUBLIC    Data          : _Sprite_;
                             Bits_Einde    : LongInt;
                             Bits_Richting : Move_Type;

                   Procedure Init(X,Y : Word; Bit : Word; D : Word);
                   Procedure Pic(A : TAnimate);
                   Procedure Animate;
                   Function  CheckGem(VAR X,Y : Word) : Word;
                   Procedure RemoveGem(X,Y : Word; _CP,_LP : Integer);
                   Procedure RemoveSprite(_LPage : Integer);
                   Procedure UpdateSprite;
                   Procedure DrawSprite;

                   Procedure MoveRight;
                   Procedure MoveLeft;
                   Procedure MoveDown;
                   Procedure MoveUp;

                   Function  Get_X : Integer;
                   Function  Get_Y : Integer;


                   Function  OK_Right : Boolean;
                   Function  OK_Left : Boolean;
                   Function  OK_Down : Boolean;
                   Function  OK_Up : Boolean;

                   PRIVATE   Bits_Loop     : LongInt;
                             Ani_Array     : TAnimate;
                             Ani_Loop      : Word;
                             WachtDelay    : Boolean;
                             MaxDelay      : Word;
                             WachtEerste   : Word;
                             WachtTweede   : Word;

                   END;

{*******DOCHTER OBJECT VAN MOEDER SPRITE************************************}
Type  OBJVriend = OBJECT (OBJSprite)

                   Procedure Init_Vriend(X,Y : Word; Bit : Word; D : Word);
                   Procedure Right;
                   Procedure Left;
                   Procedure Down;
                   Procedure Up;

                  END;

{*******DOCHTER OBJECT VAN MOEDER SPRITE************************************}
Type  OBJVijand = OBJECT (OBJSprite)

                   PUBLIC    IMMFactor  : Word;
                             BanditHunt : Boolean;

   Procedure Init_Vijand(X,Y : Word; Bit : Word; D : Word; Factor : Integer);
   Procedure Move(V : OBJSprite);
   Function  CheckDead(V : OBJSprite) : Boolean;
   Procedure SetHunt(B : Boolean);
   Procedure SetIMM(Factor : Integer);

                   PRIVATE   CheckIt    : OBJSprite;
                             Kijk       : Word;
                             DM_Links   : Word;
                             DM_Rechts  : Word;
                             DM_Onder   : Word;
                             DM_Boven   : Word;

                   Function  CheckValid(Y,X : Word) : Boolean;
                   Function  IMM : Boolean;
                   Function  BovenOfOnder : Word;
                   Function  LinksOfRechts : Word;
                   Procedure BerekenDIR(X,Y : Word);

   END;

IMPLEMENTATION

Uses Screen;

{*******DEFINITIE SPRITE OBJECT*********************************************}
Procedure OBJSprite.Init;
Var _Buffer : _SprBuf_;
Begin
  Data.XPos     := ((X-1)*SPRITE_X)+MOVE_X;
  Data.YPos     := ((Y-1)*SPRITE_Y)+MOVE_Y;
  Data.XRow     := X;
  Data.YRow     := Y;
  Data.Active   := Ja;
  Bits_Loop     := Bit;
  Bits_Einde    := 0;
  Bits_Richting := _None;

  {Setup Animation}
  Ani_Loop      := 1;
  WachtDelay    := True;
  WachtEerste   := 0;
  WachtTweede   := 0;
  MaxDelay      := D;
  FillChar(Ani_Array,SizeOf(Ani_Array),0);
End;

Procedure OBJSprite.RemoveSprite(_LPage : Integer);
Begin
  Copy_Bitmap(2,Data.LastX,
                Data.LastY,
                Data.LastX+SPRITE_X,
                Data.LastY+SPRITE_Y,
                _LPage,
                Data.LastX,
                Data.LastY);
End;

Procedure OBJSprite.UpDateSprite;
Begin
  If Data.Active <> Nee Then Begin
    Data.LastX := Data.XPos;
    Data.LastY := Data.YPos;
  End;
End;

Procedure OBJSprite.DrawSprite;
Begin
  If Data.Active <> Nee Then
    TDraw_Bitmap(Data.Buffer,Data.XPos,Data.YPos,SPRITE_X,SPRITE_Y);
End;

Function OBJSprite.CheckGem;
Var G : Word;
Begin
  If (Bits_Einde = 0) Then Begin
    CheckGem := 0;
    G := GetScr(Data.YRow,Data.XRow);
    If (G >= GEMS) And (G <= (GEMS+99))  Then Begin
      CheckGem := GetScr(Data.YRow,Data.XRow);
      X := Data.XRow;
      Y := Data.YRow;
    End;
  End;
End;

Procedure OBJSprite.RemoveGem;
Var _Buffer : _SprBuf_;
    X1,Y1   : Word;
Begin
  If (Bits_Einde = 0) Then Begin
    GetSprite(0,_Buffer);
    PutScr(Y,X,0);
    X1 := ((X-1)*SPRITE_X)+MOVE_X;
    Y1 := ((Y-1)*SPRITE_Y)+MOVE_Y;
    Set_Active_Page(2);
    Draw_Bitmap(_Buffer,X1,Y1,SPRITE_X,SPRITE_Y);
    Copy_Bitmap(2,X1,Y1,X1+SPRITE_X,Y1+SPRITE_Y,_LP,X1,Y1);
    Set_Active_Page(_CP);
    {Dec(Gems_Count);}
  End;
End;

Procedure OBJSprite.Pic;
Var _Buffer : _SprBuf_;

    Function CheckAni : Boolean;
    Var C : Byte;
        B : Boolean;
    Begin
      B := False;
      For C := 1 To 10 Do Begin
        If (A[C] <> Ani_Array[C]) Then Begin
          B := True;
          Ani_Array[C] := A[C];
        End;
      End;
      CheckAni := B;
    End;

Begin
  If (CheckAni = True) Then Begin
    GetSprite(Ani_Array[1],_Buffer);
    Data.Buffer := _Buffer;
  End;
End;

Procedure OBJSprite.Animate;
Var _Buffer : _SprBuf_;
    Result  : Word;
Begin
  If (WachtDelay = True) Then Begin
    WachtEerste := MEMW[$0040:$006C];
    WachtDelay := False;
  End;
  If (WachtDelay = False) Then Begin
    WachtTweede := MEMW[$0040:$006C];
  End;
  Result := WachtTweede-WachtEerste;
  If (Result >= MaxDelay) Then Begin
    If (Ani_Array[Ani_Loop] > 0) Then Begin
      GetSprite(Ani_Array[Ani_Loop],_Buffer);
      Data.Buffer := _Buffer;
      Inc(Ani_Loop);
      If (Ani_Loop > 10) Then Ani_Loop := 1;
    End Else Ani_Loop := 1;
    WachtDelay := True;
  End;
End;

Procedure OBJSprite.MoveRight;
Begin
  Inc(Data.XPos,Bits_Loop);
  Inc(Bits_Einde,Bits_Loop);
  If (Bits_Einde = SPRITE_X) Then Begin
    Inc(Data.XRow);
    Bits_Einde := 0;
  End;
End;

Procedure OBJSprite.MoveLeft;
Begin
  Dec(Data.XPos,Bits_Loop);
  Inc(Bits_Einde,Bits_Loop);
  If (Bits_Einde = SPRITE_X) Then Begin
    Dec(Data.XRow);
    Bits_Einde := 0;
  End;
End;

Procedure OBJSprite.MoveDown;
Begin
  Inc(Data.YPos,Bits_Loop);
  Inc(Bits_Einde,Bits_Loop);
  If (Bits_Einde = SPRITE_Y) Then Begin
    Inc(Data.YRow);
    Bits_Einde := 0;
  End;
End;

Procedure OBJSprite.MoveUp;
Begin
  Dec(Data.YPos,Bits_Loop);
  Inc(Bits_Einde,Bits_Loop);
  If (Bits_Einde = SPRITE_Y) Then Begin
    Dec(Data.YRow);
    Bits_Einde := 0;
  End;
End;



Function OBJSprite.Get_X;
Begin
  Get_X := Data.XPos;
End;

Function OBJSprite.Get_Y;
Begin
  Get_Y := Data.YPos;
End;




Function OBJSprite.OK_Left : Boolean;
Begin
  OK_Left := Data.XRow > 1;
  Bits_Richting := _None;
End;

Function OBJSprite.OK_Right : Boolean;
Begin
  OK_Right := Data.XRow < SCREEN_X;
  Bits_Richting := _None;
End;

Function OBJSprite.OK_Up : Boolean;
Begin
  OK_Up := Data.YRow > 1;
  Bits_Richting := _None;
End;

Function OBJSprite.OK_Down : Boolean;
Begin
  OK_Down := Data.YRow < SCREEN_Y;
  Bits_Richting := _None;
End;

{ --- DEFINITIE VRIEND OBJECT }

Procedure OBJVriend.Init_Vriend;
Begin
  Init(X,Y,Bit,D);
End;

Procedure OBJVriend.Right;
Begin
  If (Data.Active <> Nee) Then Begin
    If GetScr(Data.YRow,Data.XRow+1) < MUREN Then Begin
      Bits_Richting := _Right;
      MoveRight;
    End Else Bits_Richting := _None;
  End;
End;

Procedure OBJVriend.Left;
Begin
  If (Data.Active <> Nee) Then Begin
    If GetScr(Data.YRow,Data.XRow-1) < MUREN Then Begin
      Bits_Richting := _Left;
      MoveLeft;
    End Else Bits_Richting := _None;
  End;
End;

Procedure OBJVriend.Down;
Begin
  If (Data.Active <> Nee) Then Begin
    If GetScr(Data.YRow+1,Data.XRow) < MUREN Then Begin
      Bits_Richting := _Down;
      MoveDown;
    End Else Bits_Richting := _None;
  End;
End;

Procedure OBJVriend.Up;
Begin
  If (Data.Active <> Nee) Then Begin
    If GetScr(Data.YRow-1,Data.XRow) < MUREN Then Begin
      Bits_Richting := _Up;
      MoveUp;
    End Else Bits_Richting := _None;
  End;
End;

{ --- DEFINITIE VIJAND OBJECT }

Procedure OBJVijand.Init_Vijand;
Begin
  Init(X,Y,Bit,D);
  IMMFactor  := Factor;
  Kijk       := 0;
  DM_Links   := 1;
  DM_Rechts  := 2;
  DM_Onder   := 3;
  DM_Boven   := 4;
  BanditHunt := True; {True = Pakken, False = Weglopen}
End;

Function OBJVijand.CheckDead;
Begin
  {DiskMan := V;}
  CheckDead := False;
  If (Data.XRow = V.Data.XRow) And (Data.Active = Ja)
    And (Data.YRow = V.Data.YRow) Then CheckDead := True;
End;

Procedure OBJVijand.SetIMM;
Begin
  IMMFactor := Factor;
End;

Function OBJVijand.CheckValid;
Begin
  CheckValid := False;
  If (Y In [1..SCREEN_Y]) And (X In [1..SCREEN_X]) Then Begin
    CheckValid := GetScr(Y,X) < MUREN;
  End;
End;

Function OBJVijand.IMM;
Begin
  IMM := Random(IMMFactor) = 0;
End;

Function OBJVijand.BovenOfOnder;
Begin
  If IMM Then
    If (Data.YRow > CheckIt.Data.YRow) Then
      If BanditHunt Then BovenOfOnder := DM_Boven Else BovenOfOnder := DM_Onder
    Else If BanditHunt Then BovenOfOnder := DM_Onder Else BovenOfOnder := DM_Boven
  Else If Random(2) = 0 Then BovenOfOnder := DM_Onder Else BovenOfOnder := DM_Boven;
End;

Function OBJVijand.LinksOfRechts;
Begin
  If IMM Then
    If (Data.XRow > CheckIt.Data.XRow) Then
      If BanditHunt Then LinksOfRechts := DM_Links Else LinksOfRechts := DM_Rechts
    Else If BanditHunt Then LinksOfRechts := DM_Rechts Else LinksOfRechts := DM_Links
  Else If Random(2) = 0 Then LinksOfRechts := DM_Links Else LinksOfRechts := DM_Rechts;
End;

Procedure OBJVijand.BerekenDIR;
Var DD : Word;
Begin
  If (Kijk = DM_Boven) Or (Kijk = DM_Onder) Then Begin
    If (CheckValid(Y-1,X) And (Kijk = DM_Boven)) Or
        (CheckValid(Y+1,X) And (Kijk = DM_Onder)) Then Begin
      DD := LinksOfRechts;
      If (CheckValid(Y,X-1) And (DD = DM_Links)) Then Kijk := DM_Links
        Else
      If (CheckValid(Y,X+1) And (DD = DM_Rechts)) Then Kijk := DM_Rechts;
    End Else Begin
      If (CheckValid(Y,X-1) And CheckValid(Y,X+1)) Then Kijk := LinksOfRechts
        Else If CheckValid(Y,X-1) Then Kijk := DM_Links
          Else If CheckValid(Y,X+1) Then Kijk := DM_Rechts
            Else If Kijk = DM_Boven Then Kijk := DM_Onder
              Else Kijk := DM_Boven;
    End;
    Exit;
  End;
  If (Kijk = DM_Links) Or (Kijk = DM_Rechts) Then Begin
    If (CheckValid(Y,X+1) And (Kijk = DM_Rechts)) Or
        (CheckValid(Y,X-1) And (Kijk = DM_Links)) Then Begin
      DD := BovenOfOnder;
      If (CheckValid(Y-1,X) And (DD = DM_Boven)) Then Kijk := DM_Boven
        Else
      If (CheckValid(Y+1,X) And (DD = DM_Onder)) Then Kijk := DM_Onder;
    End Else Begin
      If (CheckValid(Y-1,X) And CheckValid(Y+1,X)) Then Kijk := BovenOfOnder
        Else If CheckValid(Y-1,X) Then Kijk := DM_Boven
          Else If CheckValid(Y+1,X) Then Kijk := DM_Onder
            Else If Kijk = DM_Rechts Then Kijk := DM_Links
              Else Kijk := DM_Rechts;
    End;
    Exit;
  End;
  If (Kijk = 0) Then Begin
    If CheckValid(Y,X-1) Then Kijk := DM_Links Else
      If CheckValid(Y,X+1) Then Kijk := DM_Rechts Else
        If CheckValid(Y-1,X) Then Kijk := DM_Boven Else
          If CheckValid(Y+1,X) Then Kijk := DM_Onder Else Kijk := 0;
  End;
End;

Procedure OBJVijand.Move;
Begin
  CheckIt := V;
  If (Kijk = DM_Links) Then Begin MoveLeft; Bits_Richting := _Left;
  End Else
    If (Kijk = DM_Rechts) Then Begin MoveRight; Bits_Richting := _Right;
     End Else
       If (Kijk = DM_Onder) Then Begin MoveDown; Bits_Richting := _Down;
        End Else
         If (Kijk = DM_Boven) Then Begin MoveUp; Bits_Richting := _Up;
        End;

  If (Bits_Einde = 0) Then BerekenDIR(Data.XRow,Data.YRow);
End;

Procedure OBJVijand.SetHunt; {True = Hunt, False = Runaway}
Begin
  BanditHunt := B;
End;

Begin
  Randomize;
End.