Program AniGame;

Uses Dos,Crt,Mode,Sprite,Screen,Opslag,Toetsen,Palette,Def,Timer;
{***************************************************************************}
Type  AllType = (Wachten,NaarDeur,Aanvallen,Weglopen,Dood);

Type  TAlien = RECORD
        IMG  : OBJVijand;
        Mode : AllType;
      END;
Var   Alien : Array[1..4] Of TAlien;

Type  TVriend = RECORD
        IMG  : OBJVriend;
        Mode : AllType;
      END;
Var   Vriend : TVriend;

Var   Centrum       : OBJVijand;
      Deur          : OBJVijand;
      _Screen       : _ScrBuf_;
      _CurrentPage,
      _LastPage     : Integer;
      OffSet_X,
      OffSet_Y      : Integer;

procedure CLI; inline($FA);
procedure STI; inline($FB);
{***************************************************************************}

Procedure Scroll(var X,Y : Integer; B : Byte);
Begin
  if (vriend.img.get_x > 200) And (X < 40) then inc(X,B);
  if (vriend.img.get_x < 200) And (X > 0) then dec(x,B);
  if (vriend.img.get_y > 100) And (Y < 40)  then Inc(y,B);
  if (vriend.img.get_y < 100) And (Y > 0) then dec(y,B);
  SET_WINDOW (_CurrentPage,X,Y);
End;


Procedure ReadScreen(SNr : Word);
Var F : File;
Begin
  Assign(F,'SCR30X20.SCR');
  Reset(F,1);
  Seek(F,(Snr-1)*SizeOf(_ScrBuf_));
  BlockRead(F,_Screen,SizeOf(_ScrBuf_));
  Close(F);
End;
{***************************************************************************}
Procedure Game_Stop; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;
{***************************************************************************}
Procedure Game_Init;
Begin
  If SET_VGA_MODEX(0,360,240,3) = 0 Then Begin
    Game_Stop;
    Halt(0);
  End;
End;
{***************************************************************************}
Procedure UpDate;
Begin
  Alien[1].IMG.UpdateSprite;
  Alien[2].IMG.UpdateSprite;
  Alien[3].IMG.UpdateSprite;
  Alien[4].IMG.UpdateSprite;
  Vriend.IMG.UpdateSprite;
End;
{***************************************************************************}
Procedure Draw;
Begin
  Alien[1].IMG.DrawSprite;
  Alien[2].IMG.DrawSprite;
  Alien[3].IMG.DrawSprite;
  Alien[4].IMG.DrawSprite;
  Vriend.IMG.DrawSprite;
End;
{***************************************************************************}
Procedure Remove(L : Integer);
Begin
  Alien[1].IMG.RemoveSprite(L);
  Alien[2].IMG.RemoveSprite(L);
  Alien[3].IMG.RemoveSprite(L);
  Alien[4].IMG.RemoveSprite(L);
  Vriend.IMG.RemoveSprite(L);
End;
{***************************************************************************}
Procedure VriendMove;
Begin
  {Bewegen}
  If (Spel_Richting = RECHTS) And (Vriend.IMG.OK_Right) Then Vriend.IMG.Right;
  If (Spel_Richting = LINKS) And (Vriend.IMG.OK_Left) Then Vriend.IMG.Left;
  If (Spel_Richting = ONDER) And (Vriend.IMG.OK_Down) Then Vriend.IMG.Down;
  If (Spel_Richting = BOVEN) And (Vriend.IMG.OK_Up) Then Vriend.IMG.Up;

  {Wacht Tijd Aanvallen Vriend}
  If (Vriend.Mode = Aanvallen) Then Begin
    If (_VriendTeller > VRIEND_AANVAL) Then Begin
       Vriend.Mode := WegLopen;
      _AlienTeller := 0;
    End;
  End;
End;
{***************************************************************************}
Procedure SetVriendRichting;
Var DA_Set : TAnimate;
Begin
  {VRIEND}
  If (Vriend.Mode = WegLopen) Then DA_Set := DA_Stil;
  If (Vriend.Mode = Aanvallen) Then DA_Set := DA_Weglopen;
  If (Vriend.IMG.Bits_Richting = _None) Then Vriend.IMG.Pic(DA_Set);
  If (Vriend.IMG.Bits_Richting = _Left) Then Vriend.IMG.Pic(DA_Links);
  If (Vriend.IMG.Bits_Richting = _Right) Then Vriend.IMG.Pic(DA_Rechts);
  If (Vriend.IMG.Bits_Richting = _Up) Then Vriend.IMG.Pic(DA_Boven);
  If (Vriend.IMG.Bits_Richting = _Down) Then Vriend.IMG.Pic(DA_Onder);
End;
{***************************************************************************}
Procedure SetAlienRichting;

  Procedure SetA(Spr : Byte);
  Begin
    If (Alien[Spr].Mode In [Wachten,NaarDeur,Aanvallen]) Then Begin
      If (Alien[Spr].IMG.Bits_Richting = _Left) Then Alien[Spr].IMG.Pic(AAN_Links[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Right) Then Alien[Spr].IMG.Pic(AAN_Rechts[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Up) Then Alien[Spr].IMG.Pic(AAN_Boven[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Down) Then Alien[Spr].IMG.Pic(AAN_Onder[Spr]);
    End;
    If (Alien[Spr].Mode = WegLopen) Then Begin
      If (Alien[Spr].IMG.Bits_Richting = _Left) Then Alien[Spr].IMG.Pic(AAW_Links[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Right) Then Alien[Spr].IMG.Pic(AAW_Rechts[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Up) Then Alien[Spr].IMG.Pic(AAW_Boven[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Down) Then Alien[Spr].IMG.Pic(AAW_Onder[Spr]);
    End;
    If (Alien[Spr].Mode = Dood) Then Begin
      If (Alien[Spr].IMG.Bits_Richting = _Left) Then Alien[Spr].IMG.Pic(AAD_Links[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Right) Then Alien[Spr].IMG.Pic(AAD_Rechts[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Up) Then Alien[Spr].IMG.Pic(AAD_Boven[Spr]);
      If (Alien[Spr].IMG.Bits_Richting = _Down) Then Alien[Spr].IMG.Pic(AAD_Onder[Spr]);
    End;
  End;
Begin
  SetA(1); {ALIENS}
  SetA(2); {ALIENS}
  SetA(3); {ALIENS}
  SetA(4); {ALIENS}
End;
{***************************************************************************}
Procedure VijandMove;

  Procedure CheckMode(Spr : Byte);
  Begin
    {Start/Na Dood Spel}
    If Alien[Spr].Mode = Wachten Then Begin
      {SetPicNormaal(Spr);}
      Alien[Spr].IMG.SetIMM(0);
      Alien[Spr].IMG.SetHunt(True);
      Alien[Spr].IMG.Move(Centrum);
    End;
    {Beweeg Richting Opening}
    If Alien[Spr].Mode = NaarDeur Then Begin
      {SetPicNormaal(Spr);}
      Alien[Spr].IMG.SetIMM(0);
      Alien[Spr].IMG.SetHunt(True);
      Alien[Spr].IMG.Move(Deur);
    End;
    {Na Opening, Naar Vriend}
    If Alien[Spr].Mode = Aanvallen Then Begin
      {SetPicNormaal(Spr);}
      Alien[Spr].IMG.SetIMM(Spr);
      Alien[Spr].IMG.SetHunt(True);
      Alien[Spr].IMG.Move(Vriend.IMG);
    End;
    {Weglopen Jongens}
    If Alien[Spr].Mode = Weglopen Then Begin
      {SetPicWeglopen(Spr);}
      Alien[Spr].IMG.SetIMM(0);
      Alien[Spr].IMG.SetHunt(False);
      Alien[Spr].IMG.Move(Vriend.IMG);
    End;
    {Te (Dood) Laat, Naar Huis Terug}
    If Alien[Spr].Mode = Dood Then Begin
      {SetPicDood(Spr);}
      Alien[Spr].IMG.SetIMM(0);
      Alien[Spr].IMG.SetHunt(True);
      Alien[Spr].IMG.Move(Deur);
    End;
    {Na Onze Dood Wandeling, Of Opnieuw}
    If (Alien[Spr].IMG.CheckDead(Deur) = True) Then Begin
       If (Alien[Spr].Mode = Dood) Then Alien[Spr].Mode := Wachten Else
        If (Alien[Spr].Mode = NaarDeur) Then Alien[Spr].Mode := Aanvallen;
    End;
    {Kijk Naar Vriend, Indien Weer Normaal, Alien Aanvallen}
    If (Alien[Spr].Mode = WegLopen) And (Vriend.Mode = WegLopen)
      Then Alien[Spr].Mode := Aanvallen;
  End;

  Function NDeurControle(Spr : Byte) : Boolean;
  Begin
    NDeurControle := False;
    If (Alien[Spr].Mode = Wachten)
      And (Vriend.Mode = WegLopen) Then NDeurControle := True;
  End;

Begin
  CheckMode(1);
  CheckMode(2);
  CheckMode(3);
  CheckMode(4);

  {Controle Wacht --> Aanval Mode}
  If (_AlienTeller > WACHTEN_ALIEN) Then Begin
    If (NDeurControle(1) = True) Then Alien[1].Mode := NaarDeur Else
      If (NDeurControle(2) = True) Then Alien[2].Mode := NaarDeur Else
        If (NDeurControle(3) = True) Then Alien[3].Mode := NaarDeur Else
          If (NDeurControle(4) = True) Then Alien[4].Mode := NaarDeur;
   _AlienTeller := 0;
  End;
End;
{***************************************************************************}
Procedure Botsing(Spr : Byte);
Begin
  If Alien[Spr].IMG.CheckDead(Vriend.IMG) = True Then Begin
    If (Alien[Spr].Mode = Weglopen) Then Alien[Spr].Mode := Dood;
  End;
End;
{***************************************************************************}
Procedure CheckBotsing;
Begin
  Botsing(1);
  Botsing(2);
  Botsing(3);
  Botsing(4);

End;
{***************************************************************************}
Procedure Animate;
Begin
  Alien[1].IMG.Animate;
  Alien[2].IMG.Animate;
  Alien[3].IMG.Animate;
  Alien[4].IMG.Animate;
  Vriend.IMG.Animate;
End;
{***************************************************************************}
Procedure CheckGem;
Var X,Y,G : Word;
Begin
  G := Vriend.IMG.CheckGem(X,Y);
  If (G >= GEMS) And (G < MUREN) Then Begin
    Vriend.IMG.RemoveGem(X,Y,_CurrentPage,_LastPage);
    Dec(Gems_Count);
    {ADLSound(440);}
    If (Gems_Count = 0) Then ESC := TRUE;
  End;
  If (G = SuperPower) Then Begin
    {VERANDERD, TOEGEVOEGD --> NAARDEUR}
    If Alien[1].Mode In [Aanvallen,NaarDeur] Then Alien[1].Mode := WegLopen;
    If Alien[2].Mode In [Aanvallen,NaarDeur] Then Alien[2].Mode := WegLopen;
    If Alien[3].Mode In [Aanvallen,NaarDeur] Then Alien[3].Mode := WegLopen;
    If Alien[4].Mode In [Aanvallen,NaarDeur] Then Alien[4].Mode := WegLopen;
    Vriend.Mode := Aanvallen;
    _VriendTeller := 0;
    {ADLSound(294);}
  End;
End;
{***************************************************************************}
Procedure CheckDood;

  Procedure Dood(Spr : Byte);
  Begin
    If (Alien[Spr].Mode = Aanvallen)
      And (Alien[Spr].IMG.CheckDead(Vriend.IMG) = True) Then ESC := FALSE;
  End;

Begin
  Dood(1);
  Dood(2);
  Dood(3);
  Dood(4);
End;
{***************************************************************************}
Procedure Init_All;
Var _X,_Y,_Bits,_Delay : Byte;
Begin
  _X     := 15;
  _Y     := 15;
  _Bits  := 3;
  _Delay := _Bits;

  Vriend.IMG.Init_Vriend(_X,_Y,_Bits,1);
  Vriend.IMG.Pic(DA_Stil);
  Vriend.Mode := WegLopen;

  Alien[1].IMG.Init_Vijand(14,11,_Bits,_Delay,0);
  Alien[2].IMG.Init_Vijand(14,13,_Bits,_Delay,0);
  Alien[3].IMG.Init_Vijand(17,11,_Bits,_Delay,0);
  Alien[4].IMG.Init_Vijand(17,13,_Bits,_Delay,0);

  Centrum.Init_Vijand(16,12,0,0,0);
  Deur.Init_Vijand(15,10,0,0,0);

  Alien[1].Mode := Wachten;
  Alien[2].Mode := Wachten;
  Alien[3].Mode := Wachten;
  Alien[4].Mode := Wachten;

  _AlienTeller := 0;
  _CurrentPage := 1;
  _LastPage    := 0;
End;
{*****HOOFDPROGRAMMA********************************************************}
BEGIN
  ClrScr;
  ReadSprites('SPR12X12.SPR');
  Game_Init;
  ReadPalette; {NA INIT ZETTEN}
  ReadScreen(1); {VERANDEREN}
  BuildScreen(_Screen);
  Init_All;
  CLI;


  OffSet_X := 1;
  OffSet_Y := 1;

  REPEAT
      HaalToetsen(Vriend.IMG);
      Set_Active_Page(_CurrentPage);
      UpDate;
      VriendMove;
      SetVriendRichting;
      SetAlienRichting;
      CheckDood;
      VijandMove;
      CheckBotsing;
      Animate;
      Draw;
      Set_Display_Page(_Currentpage);
      Remove(_LastPage);
      CheckGem; {HIER, NERGENS ANDERS}
      Scroll(OffSet_X,OffSet_Y,1);
      _LastPage := (_LastPage+1) MOD 2;
      _CurrentPage := (_CurrentPage+1) MOD 2;
  UNTIL ESC = True;
  STI;
  Game_Stop;
END.