Function Exist(Filename : STRING) : BOOLEAN;
Var SR : SearchRec;
Begin
  FindFirst(FileName, ReadOnly + Hidden + SysFile, SR);
  Exist := (DosError = 0) and (Pos('?', FileName) = 0) and
            (Pos('*', FileName) = 0);
End;

Procedure HaalHiScore;
Begin
  If Exist('DISKMAN.HI') Then Begin
    Assign(HiScoreFile,'DISKMAN.HI');
    Reset(HiScoreFile);
    Read(HiScoreFile,HiScoreRec);
    Close(HiScoreFile);
  End Else Begin
    Assign(HiScoreFile,'DISKMAN.HI');
    Rewrite(HiScoreFile);
    FillChar(HiScoreRec,SizeOf(HiScoreRec),0);
    Write(HiScoreFile,HiScoreRec);
    Close(HiScoreFile);
  End;
End;

Procedure SchrijfHiScore;
Begin
  Assign(HiScoreFile,'DISKMAN.HI');
  Rewrite(HiScoreFile);
  Write(HiScoreFile,HiScoreRec);
  Close(HiScoreFile);
End;

Procedure HaalSprites;
Var Count : Word;

  Procedure SpriteAanmaken;
  Var Count : Word;
  Begin
    Assign(SpriteFile,SPRITENAAM);
    ReWrite(SpriteFile);
    FillChar(SpriteOnes,SizeOf(SpriteOnes),0);
    For Count := 0 To MAXSPRITE Do Begin
      Write(SpriteFile,SpriteOnes);
      GetMem(SpriteRec[Count],SizeOf(SpriteOnes));
      Move(SpriteOnes,SpriteRec[Count]^,SizeOf(SpriteOnes));
    End;
    Close(SpriteFile);
  End;

Begin
  If Not Exist(SPRITENAAM) Then SpriteAanmaken Else Begin
    Assign(SpriteFile,SPRITENAAM);
    Reset(SpriteFile);
    For Count := 0 To MAXSPRITE Do Begin
      Read(SpriteFile,SpriteOnes);
      GetMem(SpriteRec[Count],SizeOf(SpriteOnes));
      Move(SpriteOnes,SpriteRec[Count]^,SizeOf(SpriteOnes));
    End;
    Close(SpriteFile);
  End;
End;

Procedure HaalFont;
Var Count : Word;

  Procedure FontAanmaken;
  Var Count : Word;
  Begin
    Assign(FontFile,FONTNAAM);
    ReWrite(FontFile);
    FillChar(FontOnes,SizeOf(FontOnes),0);
    For Count := 0 To MAXFONT Do Begin
      Write(FontFile,FontOnes);
      GetMem(FontRec[Count],SizeOf(FontOnes));
      Move(FontOnes,FontRec[Count]^,SizeOf(FontOnes));
    End;
    Close(FontFile);
  End;

Begin
  If Not Exist(FONTNAAM) Then FontAanmaken Else Begin
    Assign(FontFile,FontNAAM);
    Reset(FontFile);
    For Count := 0 To MAXFONT Do Begin
      Read(FontFile,FontOnes);
      GetMem(FontRec[Count],SizeOf(FontOnes));
      Move(FontOnes,FontRec[Count]^,SizeOf(FontOnes));
    End;
    Close(FontFile);
  End;
End;


Procedure HaalScreen;
Var Count : Word;

  Procedure ScreenAanmaken;
  Var Count : Word;
  Begin
    Assign(ScreenFile,SCREENNAAM);
    ReWrite(ScreenFile);
    FillChar(ScreenOnes,SizeOf(ScreenOnes),0);
    For Count := 1 To MAXScreen Do Begin
      Write(ScreenFile,ScreenOnes);
      GetMem(ScreenRec[Count],SizeOf(ScreenOnes));
      Move(ScreenOnes,ScreenRec[Count]^,SizeOf(ScreenOnes));
    End;
    Close(ScreenFile);
  End;

Begin
  If Not Exist(ScreenNAAM) Then ScreenAanmaken Else Begin
    Assign(ScreenFile,SCREENNAAM);
    Reset(ScreenFile);
    For Count := 1 To MAXScreen Do Begin
      Read(ScreenFile,ScreenOnes);
      GetMem(ScreenRec[Count],SizeOf(ScreenOnes));
      Move(ScreenOnes,ScreenRec[Count]^,SizeOf(ScreenOnes));
    End;
    Close(ScreenFile);
  End;
End;

Procedure SchrijfScreen;
Var Count : Word;
Begin
  Assign(ScreenFile,SCREENNAAM);
  ReWrite(ScreenFile);
  For Count := 1 To MAXSCREEN Do Begin
    Write(ScreenFile,ScreenRec[Count]^);
  End;
  Close(ScreenFile);
End;

Procedure SchrijfSprites;
Var Count : Word;
Begin
  Assign(SpriteFile,SPRITENAAM);
  ReWrite(SpriteFile);
  For Count := 0 To MAXSPRITE Do Begin
    Write(SpriteFile,SpriteRec[Count]^);
  End;
  Close(SpriteFile);
End;

Procedure SchrijfFont;
Var Count : Word;
Begin
  Assign(FontFile,FONTNAAM);
  ReWrite(FontFile);
  For Count := 0 To MAXFONT Do Begin
    Write(FontFile,FontRec[Count]^);
  End;
  Close(FontFile);
End;

{
Procedure Conv15X15;
Var OUT   : Text;
    T,X,Y : Word;
Begin
  Assign(OUT,SPRITEINC);
  Rewrite(OUT);
  WriteLn(OUT,'Const SprData    : Array[0..',MAXSPRITE:3,',1..H,1..B] Of Byte = (');
  For T := 0 To MAXSPRITE Do Begin
    SpriteOnes := SpriteRec[T]^;
    For X := 1 To BREEDTE Do Begin
      If X <> 1 Then Write(OUT,' (') Else Write(OUT,'((');
      For Y := 1 To HOOGTE Do Begin
        If Y <> HOOGTE Then Write(OUT,SpriteOnes.Buffer[X,Y]:2,',') Else Write(OUT,SpriteOnes.Buffer[X,Y]:2);
      End;
      If X = BREEDTE Then Write(OUT,'))') Else Write(OUT,')');
      If (Y = HOOGTE) And
          (X = BREEDTE) And
           (T = MAXSPRITE) Then WriteLn(OUT,');') Else WriteLn(OUT,',');
    End;
    WriteLn(OUT);
  End;
  Close(OUT);
End;

Procedure Conv8X8;
Var OUT   : Text;
    T,X,Y : Word;
Begin
  Assign(OUT,FONTINC);
  Rewrite(OUT);
  WriteLn(OUT,'Const Digits    : Array[0..',MAXFONT:3,',1..8,1..8] Of Byte = (');
  For T := 0 To MAXFONT Do Begin
    FontOnes := FontRec[T]^;
    For X := 1 To 8 Do Begin
      If X <> 1 Then Write(OUT,' (') Else Write(OUT,'((');
      For Y := 1 To 8 Do Begin
        If Y <> 8 Then Write(OUT,FontOnes.Buffer[X,Y]:2,',') Else Write(OUT,FontOnes.Buffer[X,Y]:2);
      End;
      If X = 8 Then Write(OUT,'))') Else Write(OUT,')');
      If (Y = 8) And
          (X = 8) And
           (T = MAXFONT) Then WriteLn(OUT,');') Else WriteLn(OUT,',');
    End;
    WriteLn(OUT);
  End;
  Close(OUT);
End;
}