Program AniGame;

Uses Dos,Crt,Mode,Sprite,Screen,Opslag,
     Toetsen,Palette,Def,Timer,Score;

Type  AllType = (Wachten,NaarDeur,Aanvallen,Weglopen,Dood);

Type  TAlien = RECORD
        IMG  : OBJVijand;
        Mode : AllType;
      END;
Var   Alien : Array[1..4] Of TAlien;

Type  TVriend = RECORD
        IMG  : OBJVriend;
        Mode : AllType;
      END;
Var   Vriend : TVriend;

Var   Centrum       : OBJVijand;
      Deur          : OBJVijand;
      _Screen       : _ScrBuf_;
      _CurrentPage,
      _LastPage     : Integer;
      AlienSpeed    : Word;

Procedure CLI; Inline($FA);
Procedure STI; Inline($FB);

Procedure ReadScreen;
Var F : File;
Begin
  Assign(F,'SCR30X20.SCR');
  Reset(F,1);
  BlockRead(F,_Screen,SizeOf(_ScrBuf_));
  Close(F);
End;

Procedure Game_Stop; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;

Procedure Game_Init;
Begin
  If SET_VGA_MODEX(6,360,240,3) = 0 Then Begin
    Game_Stop;
    Halt(0);
  End;
End;

Procedure UpDate;
Begin
  Alien[1].IMG.UpdateSprite;
  Alien[2].IMG.UpdateSprite;
  Alien[3].IMG.UpdateSprite;
  Alien[4].IMG.UpdateSprite;
  Vriend.IMG.UpdateSprite;
End;

Procedure Draw;
Begin
  Alien[1].IMG.DrawSprite;
  Alien[2].IMG.DrawSprite;
  Alien[3].IMG.DrawSprite;
  Alien[4].IMG.DrawSprite;
  Vriend.IMG.DrawSprite;
End;

Procedure Remove(L : Integer);
Begin
  Alien[1].IMG.RemoveSprite(L);
  Alien[2].IMG.RemoveSprite(L);
  Alien[3].IMG.RemoveSprite(L);
  Alien[4].IMG.RemoveSprite(L);
  Vriend.IMG.RemoveSprite(L);
End;

Procedure Animate;
Begin
  If (_AnimateTeller >= ANIMATE_DELAY) Then Begin
    Alien[1].IMG.Animate;
    Alien[2].IMG.Animate;
    Alien[3].IMG.Animate;
    Alien[4].IMG.Animate;
    Vriend.IMG.Animate;
    _AnimateTeller := 0;
  End;
End;

Procedure CheckGem;
Var X,Y,G : Word;
Begin
  G := Vriend.IMG.CheckGem(X,Y);
  If (G >= GEMS) And (G < MUREN) Then Begin
    Vriend.IMG.RemoveGem(X,Y,_CurrentPage,_LastPage);
    Dec(Gems_Count);
    UpDateScore(Pil);
    If (Gems_Count = 0) Then ESC := TRUE;
  End;
  If (G = SuperPower) Then Begin
    If (Alien[1].Mode In [Aanvallen,NaarDeur]) Then Alien[1].Mode := WegLopen;
    If (Alien[2].Mode In [Aanvallen,NaarDeur]) Then Alien[2].Mode := WegLopen;
    If (Alien[3].Mode In [Aanvallen,NaarDeur]) Then Alien[3].Mode := WegLopen;
    If (Alien[4].Mode In [Aanvallen,NaarDeur]) Then Alien[4].Mode := WegLopen;
    Vriend.Mode := Aanvallen;
    _VriendTeller := 0;
    UpDateScore(Power);
  End;
End;

{$I VRIEND.INC}
{$I VIJAND.INC}

Procedure Controle;
Begin
 If SPATIE Then Begin
   Vriend.IMG.Test; {TESTEN}
 End;
End;

Var _X,_Y,_Delay : Byte;
Begin
  ClrScr;

  ReadSprites('SPR12X12.SPR');
  ReadFont('FONT8X8.FNTD');

  Game_Init;

  ReadPalette; {NA INIT ZETTEN}
  ReadScreen;
  {ReadScoreDAT;}


  BuildScreen(_Screen);

  { X     = XRow           }
  { Y     = YRow           }
  { Bits  = Verschuiving   }
  { Delay = Animatie       }
  _X         := 15;
  _Y         := 15;
  AlienSpeed := 2;

  Vriend.IMG.Init_Vriend(_X,_Y,AlienSpeed);
  Vriend.IMG.Pic(DA_Stil);
  Vriend.Mode := WegLopen;

  { IMM  = Factor > Alien  }
  Alien[1].IMG.Init_Vijand(14,12,AlienSpeed,0);
  Alien[2].IMG.Init_Vijand(15,12,AlienSpeed,0);
  Alien[3].IMG.Init_Vijand(16,12,AlienSpeed,0);
  Alien[4].IMG.Init_Vijand(16,13,AlienSpeed,0);

  Centrum.Init_Vijand(15,12,0,0);
  Deur.Init_Vijand(15,10,0,0);

  Alien[1].Mode := Wachten;
  Alien[2].Mode := Wachten;
  Alien[3].Mode := Wachten;
  Alien[4].Mode := Wachten;

  _AlienTeller   := 0;
  _AnimateTeller := 0;
  _CurrentPage   := 1;
  _LastPage      := 0;

  CLI;
  Repeat
    HaalToetsen(Vriend.IMG);
    Set_Active_Page(_CurrentPage);
    UpDate;
    VriendMove;
    SetVriendRichting;
    SetAlienRichting;
    CheckDood;
    VijandMove;
    CheckBotsing;
    Animate;
    Controle;
    Draw;
    Set_Display_Page(_Currentpage);
    Remove(_LastPage);
    CheckGem; {HIER, NERGENS ANDERS}
    ScoreOpNUL;
    _LastPage := (_LastPage+1) MOD 2;
    _CurrentPage := (_CurrentPage+1) MOD 2;
  Until ESC = True;
  STI;
  Game_Stop;
End.