Unit Mode;

INTERFACE

Function  SET_VGA_MODEX (Mode,MaxXpos,MaxYpos,Pages : Integer) : integer;
Function  SET_MODEX (Mode:integer) : Integer;
Procedure CLEAR_VGA_SCREEN (Color:integer);
Procedure SET_ACTIVE_PAGE (PageNo:integer);
Procedure SET_DISPLAY_PAGE (PageNo:integer);
Procedure DRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer);
Procedure TDRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer);
Procedure COPY_PAGE (SourcePage,DestPage:integer);
Procedure COPY_BITMAP (SourcePage,X1,Y1,X2,Y2,DestPage,DestX1,DestY1:integer);

IMPLEMENTATION

{$L MODEX.OBJ}

{$F+}
{ Mode Setting Routines }
Function SET_VGA_MODEX (Mode,MaxXpos,MaxYpos,Pages : Integer) : integer; External;
Function SET_MODEX (Mode:integer) : Integer; External;

{ Graphics Primitives }
Procedure CLEAR_VGA_SCREEN (Color:integer); External;
(*
Procedure SET_POINT (Xpos,Ypos,Color : integer); {external;}
Function READ_POINT (Xpos,Ypos:integer) : integer; {external;}
Procedure FILL_BLOCK (Xpos1,Ypos1,Xpos2,Ypos2,Color:integer); {external;}
Procedure DRAW_LINE (Xpos1,Ypos1,Xpos2,Ypos2,Color:integer); {external;}

{ VGA DAC Routines }
Procedure SET_DAC_REGISTER (RegNo,Red,Green,Blue:integer); external;
Procedure GET_DAC_REGISTER (RegNo,Red,Green,Blue:integer); external;
Procedure LOAD_DAC_REGISTERS(Var PalData; StartReg, EndReg : Integer; Sync : Boolean); External;
Procedure READ_DAC_REGISTERS(Var PalData; StartReg, EndReg : Integer); External;

{ Page and Window Control Routines }
*)
Procedure SET_ACTIVE_PAGE (PageNo:integer); External;
(*
Function GET_ACTIVE_PAGE : integer; external;
*)
Procedure SET_DISPLAY_PAGE (PageNo:integer); External;
(*
Function GET_DISPLAY_PAGE : integer; external;
Procedure SET_WINDOW (DisplayPage,XOffset,YOffset : integer); external;
Function GET_X_OFFSET : integer; external;
Function GET_Y_OFFSET : integer; external;
Procedure SYNC_DISPLAY; external;

{ Text Display Routines }
Procedure GPRINTC (CharNum,Xpos,Ypos,ColorF,ColorB:integer); external;
Procedure TGPRINTC ( CharNum,Xpos,Ypos,ColorF : integer); external;
Procedure PRINT_STR (Var Text;MaxLen,Xpos,Ypos,ColorF,ColorB:integer); external;
Procedure TPRINT_STR (Var Text;MaxLen,Xpos,Ypos,ColorF:integer); external;
Procedure SET_DISPLAY_FONT (Var FontData;FontNumber:integer); external;

{ Sprite and VGA memory -> Vga memory Copy Routines }
*)
Procedure DRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer); External;
Procedure TDRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer); External;
Procedure COPY_PAGE (SourcePage,DestPage:integer); External;
Procedure COPY_BITMAP (SourcePage,X1,Y1,X2,Y2,DestPage,DestX1,DestY1:integer); External;
{$F-}

End.